/*
 * NIST HL7 WebService
 * TestPVAxis2v1_2.java June 15, 2007
 *
 * This code was produced by the National Institute of Standards and
 * Technology (NIST). See the "nist.disclaimer" file given in the distribution 
 * for information on the use and redistribution of this software.
 */
package main;

import java.io.FileInputStream;
import gov.nist.hl7.ws.validation.profilevalidation.*;
import gov.nist.hl7.ws.validation.profilevalidation.ProfileValidationProfileValidationSOAP11PortStub.*;

/**
 * @author Roch Bertucat (NIST)
 * This class is a basic Apache Axis2-implemented client to use 
 * with the NIST validation module web service hosted on http://xreg2.nist.gov:8080/axis2/services/
 */
public class TestPVAxis2v1_2 {

    /**
     * @param args
     */
    public static void main(String[] args) {
        try {
            // Transform Files to string
            FileInputStream fis = new FileInputStream("files/profile/BadMsgTypeEventTypeCombination.xml");
            byte b[]= new byte[fis.available()];
            fis.read(b);
            String profile = new String(b);

            fis = new FileInputStream("files/context/ProfileValidationContext.xml");
            b = new byte[fis.available()];
            fis.read(b);
            String profValidContext = new String(b);
            fis.close();
            
            // Create the connector
            ProfileValidationProfileValidationSOAP11PortStub pvs = 
                new ProfileValidationProfileValidationSOAP11PortStub("http://xreg2.nist.gov:8080/axis2/services/ProfileValidation");
//            ProfileValidationProfileValidationSOAP11PortStub pvs = 
//                new ProfileValidationProfileValidationSOAP11PortStub("http://localhost:8080/axis2/services/ProfileValidation");
            
            // Initiate WS Parameters
            SetProfile typeProfile = new SetProfile();
            typeProfile.setParam0(profile);

            SetProfileValidationContext validationContext = new SetProfileValidationContext();
            validationContext.setParam0(profValidContext);
            
            // Set files on the WS
            //SetProfileValidationContextResponse respContact = pvs.setProfileValidationContext(validationContext);
            SetProfileResponse respProfile = pvs.setProfile(typeProfile);
            GetLastExceptionMessageResponse respError = pvs.getLastExceptionMessage();
            System.out.println(respError.get_return());
            
            // Call the validation method
            if (respProfile.get_return()) {
                ValidateResponse vr = pvs.validate();
                if (vr.get_return()) 
                    System.out.println ("Profile Valid");
                else 
                    System.out.println ("Profile Not Valid");
            }
            
            respError = pvs.getLastExceptionMessage();
            System.out.println(respError.get_return());
            
            // Display the validation report
            GetProfileValidationReportResponse reportResponse = pvs.getProfileValidationReport();
            System.out.println(reportResponse.get_return());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
